/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.Logging;

import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;
import org.apache.log4j.nt.NTEventLogAppender;

public class Log4JWindowsNTEvent {

	public static void main(String[] args) {

		// specify pattern for layout
		PatternLayout myLayout =
			new PatternLayout("%-4r [%t] %-5p %c %x - %m%n");

		// get a logger instance called "Log4JWindowsEvent"
		Logger myLogger = Logger.getLogger("Log4JWindowsNTEvent");

		String mySource = "the source";

		// create an NTEventLogAppender
		NTEventLogAppender eventLogAppender = new NTEventLogAppender(mySource,myLayout);
		//create a console appender	
		ConsoleAppender consoleAppender = new ConsoleAppender(myLayout);
		
		// associate the appenders to the logger
		myLogger.addAppender(consoleAppender);
		myLogger.addAppender(eventLogAppender);

		//		log events using the logger object
		//		note that since we have associated a 
		//		level of WARN for our logger, we will not see INFO  
		//		and DEBUG STATEMENTS
		//		remember: DEBUG < INFO < WARN < ERROR < FATAL
//		myLogger.setLevel(Level.WARN);
		myLogger.setLevel(Level.INFO);
		
		// log a fatal event 
		myLogger.info("info: I have died of thirst");
		myLogger.warn("warn: I have died of thirst");
		myLogger.error("error: I have died of thirst");
		myLogger.fatal("fatal: I have died of thirst");

	}
}
