/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/*
 * Copyright 2009 Lukasz Wozniak
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 * http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */
package com.sos.VirtualFileSystem.CredentialStore.KeePass.pl.sind.keepass.kdb;
public final class KeePassConst {
	@SuppressWarnings("unused") private final String		conClassName					= this.getClass().getSimpleName();
	@SuppressWarnings("unused") private static final String	conSVNVersion					= "$Id$";
	//KDB KeePass 1.x
	public static final int									KDB_FILE_VERSION				= 0x00030002;
	//	public static final int KDB_FILE_VERSION = 0x00030004;
	public static final int									KDB_FILE_VERSION_CRITICAL_MASK	= 0xFFFFFFFF;
	public static final int									KDB_SIG_1						= 0x9AA2D903;
	public static final int									KDB_SIG_2						= 0xB54BFB65;
	//KDBX KeePass 2.x
	public static final int									KDBX_FILE_VERSION				= 0x00020000;
	public static final int									KDBX_FILE_VERSION_CRITICAL_MASK	= 0xFFFF0000;
	public static final int									KDBX_SIG_1						= 0x9AA2D903;
	public static final int									KDBX_SIG_2						= 0xB54BFB67;
	public static final byte								KDB_FLAG_SHA_2					= 0x1;
	public static final byte								KDB_FLAG_AES					= 0x2;
	public static final byte								KDB_FLAG_ARC4					= 0x4;
	public static final byte								KDB_FLAG_TWOFISH				= 0x8;
}
