/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/**
 *
 */
package com.sos.VirtualFileSystem.Filter;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import org.apache.log4j.Logger;

/**
 * @author KB
 *
 */
public class SOSDos2UnixFilter extends SOSNullFilter {

	private final String		conClassName	= this.getClass().getSimpleName();
	@SuppressWarnings("unused")
	private static final String	conSVNVersion	= "$Id: SOSDos2UnixFilter.java 22070 2014-01-09 12:40:40Z kb $";
	private final Logger		logger			= Logger.getLogger(this.getClass());

	/**
	 *
	 */
	public SOSDos2UnixFilter() {
		super();
	}

	public SOSDos2UnixFilter(final SOSFilterOptions pobjOptions) {
		super(pobjOptions);
	}

	@Override
	protected void doProcess() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::doProcess";

		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		DataOutputStream dos = new DataOutputStream(baos);

		byte b = -1;
		byte nb = -1;
		int j = 0;
		int iLen = bteBuffer.length;
		String strT = "";
		for (byte element : bteBuffer) {
			strT += element + " ";
		}
		logger.debug(strT);

		try {
			for (int i = 0; i < iLen; i++) {
				b = bteBuffer[i];
				if (b == 13) {
					if (i < iLen) {
						nb = bteBuffer[++i];
					}
					else {
						nb = -1;
					}
					if (nb == -1) {
						dos.write(b);
					}
					else {
						if (nb == 10) {
							dos.write(nb);
						}
						else {
							dos.write(b);
							dos.write(nb);
						}
					}
				}
				else {
					dos.write(b);
				}
			}

			dos.flush();
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		bteBuffer = baos.toByteArray();

		strT = "";
		for (byte element : bteBuffer) {
			strT += element + " ";
		}
		logger.debug(strT);
		logger.debug(byte2String(bteBuffer));

	} // private void doProcess

}
