/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/**
 *
 */
package com.sos.VirtualFileSystem.Filter;

import java.io.File;
import java.io.IOException;
import java.util.Vector;

import org.apache.log4j.Logger;

import com.sos.JSHelper.Basics.JSToolBox;
import com.sos.JSHelper.Options.SOSOptionFolderName;
import com.sos.JSHelper.io.Files.JSFile;

/**
 * @author KB
 *
 */
public class SOSFilteredFileReader extends JSToolBox implements ISOSFilteredFileReader {

	private final String			conClassName		= this.getClass().getSimpleName();
	@SuppressWarnings("unused")
	private static final String		conSVNVersion		= "$Id: SOSFilteredFileReader.java 22070 2014-01-09 12:40:40Z kb $";
	private final Logger			logger				= Logger.getLogger(this.getClass());

	protected SOSFilterOptions		objFilterOptions	= null;
	private JSFile					objFile2Read		= null;
	private ISOSFilteredFileReader	objProcessHandler	= this;

	public SOSFilteredFileReader() {
		super();
		logger.debug(conClassName);
	}

	public SOSFilteredFileReader(final JSFile pobjJSFile) {
		this();
		objFile2Read = pobjJSFile;
	}

	public void Options(final SOSFilterOptions pobjOptions) {
		objFilterOptions = pobjOptions;
	}

	public SOSFilterOptions Options() {
		if (objFilterOptions == null) {
			objFilterOptions = new SOSFilterOptions();
		}
		return objFilterOptions;
	}

	public void setProcesshandler(final ISOSFilteredFileReader pobjProcessHandler) {
		objProcessHandler = pobjProcessHandler;
	}

	public void setFile(final JSFile pobjJSFile) {
		objFile2Read = pobjJSFile;
	}

	public void runMultipleFiles(final String pstrPathName) {
		SOSOptionFolderName objFN = new SOSOptionFolderName(pstrPathName);
		for (File file : objFN.listFiles()) {
			this.setFile(new JSFile(file.getAbsolutePath()));
			this.run();
		}
	}

	private Vector<SOSNullFilter>	lstFilters	= null;

	public void run() {

		if (lstFilters == null) {
			lstFilters = objFilterOptions.getFilter();
		}

		StringBuffer strBuffer = null;
		while ((strBuffer = objFile2Read.GetLine()) != null) {
			String strB = strBuffer.toString();
			for (SOSNullFilter sosNullFilter : lstFilters) {
				sosNullFilter.write(strB);
				strB = sosNullFilter.readString();
			}
			if (strB != null) {
				objProcessHandler.processRecord(strB);
			}
		}

		try {
			objFile2Read.close();
			objFilterOptions.startPostProcessing(null);
			objFilterOptions.startCloseProcessing(null);
		}
		catch (IOException e) {
			e.printStackTrace();
		}

	}

	@Override
	public void processRecord(final String pstrRecord) {

		//		System.out.println(pstrRecord);
	}

	@Override
	public void atStartOfData() {

	}

	@Override
	public void atEndOfData() {

	}

}
