/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/**
 *
 */
package com.sos.dialog.classes;

import org.apache.log4j.Logger;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

import com.sos.dialog.interfaces.ISOSTabItem;

/**
 * @author KB
 *
 */
public class SOSCTabItem extends CTabItem {

	@SuppressWarnings("unused") private final String conClassName = this.getClass().getSimpleName();
	@SuppressWarnings("unused") private static final String conSVNVersion = "$Id: SOSCTabItem.java 23878 2014-04-22 18:02:41Z kb $";
	@SuppressWarnings("unused") private final Logger logger = Logger.getLogger(this.getClass());

	@SuppressWarnings("unused") private SOSCTabFolder objTabFolder = null;
	@SuppressWarnings("unused") private ISOSTabItem objTabComposite = null;

	/**
	 * @param parent
	 * @param style
	 */
	public SOSCTabItem(final SOSCTabFolder parent, final int style) {
		super(parent, style);
		objTabFolder = parent;
	}

	public Composite getComposite () {
		return (Composite) getData("composite");
	}
	
	public void setComposite (final ISOSTabItem pobjComposite) {
		setData("composite", pobjComposite);
		setData(pobjComposite);
		objTabComposite = pobjComposite;
	}

	/**
	 * @param parent
	 * @param style
	 * @param index
	 */
	public SOSCTabItem(final CTabFolder parent, final int style, final int index) {
		super(parent, style, index);
	}

	public void setParent (final SOSCTabFolder pobjTabFolder ) {

	}
	
	@Override
	public void dispose () {
		Control objC = this.getControl();
		if (objC != null && objC.isDisposed() == false) {
			objC.dispose();
			setData(null);
			setData("composite", null);
			this.setControl(null);
			this.dispose();
		}
	}
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
		}

}
