/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.dialog.classes;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.sos.dialog.components.IntegerField;
 
public class SOSIntegerInputDialog extends Dialog {
 

private static final String CAPTION_CANCEL = "Cancel";
private static final String CAPTION_OK = "Ok";
private Integer value;
private Shell shell;
private Label lbNumber;
 
  public SOSIntegerInputDialog(Shell parent) {
    super(parent);
  }
 
 
  public SOSIntegerInputDialog(Shell parent, int style) {
    super(parent, style);
  }
 
 
  public Integer open() {
    Shell parent = getParent();
    shell =  new Shell(parent, SWT.TITLE | SWT.BORDER | SWT.APPLICATION_MODAL);
    shell.setSize(152, 90);
 
    shell.setLayout(new GridLayout(2, true));
    Point pt = shell.getDisplay().getCursorLocation();
    shell.setLocation(pt.x, pt.y);
    
    lbNumber = new Label(shell, SWT.NULL);
    lbNumber.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
    lbNumber.setText("Number");
    final IntegerField integerValue = new IntegerField(shell, SWT.SINGLE | SWT.BORDER);
    integerValue.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
    integerValue.setText(value);
 
    final Button buttonOK = new Button(shell, SWT.PUSH);
    buttonOK.setText(CAPTION_OK);
    GridData gd_buttonOK = new GridData(GridData.HORIZONTAL_ALIGN_END);
    gd_buttonOK.grabExcessHorizontalSpace = true;
    buttonOK.setLayoutData(gd_buttonOK);
    buttonOK.setEnabled(true);
    Button buttonCancel = new Button(shell, SWT.PUSH);
    buttonCancel.setText(CAPTION_CANCEL);
  
    buttonOK.addListener(SWT.Selection, new Listener() {
      public void handleEvent(Event event) {
        value = integerValue.getIntegerValue(500);
        shell.dispose();
      }
    });
 
    buttonCancel.addListener(SWT.Selection, new Listener() {
      public void handleEvent(Event event) {
        value = null;
        shell.dispose();
      }
    });
    shell.addListener(SWT.Traverse, new Listener() {
      public void handleEvent(Event event) {
        if(event.detail == SWT.TRAVERSE_ESCAPE)
          event.doit = false;
      }
    });
 
    integerValue.setText(value);
    shell.pack();
    shell.open();
 
    Display display = parent.getDisplay();
    while (!shell.isDisposed()) {
      if (!display.readAndDispatch())
        display.sleep();
    }
 
    return value;
  }
  
  public void setDialogCaption(String caption) {
      shell.setText(caption);
  }
  
  public void setLableCaption(String caption) {
      lbNumber.setText(caption);
      
  }
 
  public static void main(String[] args) {
    Shell shell = new Shell();
    SOSIntegerInputDialog dialog = new SOSIntegerInputDialog(shell);
    System.out.println(dialog.open());
  }


public void setValue(Integer value) {
    this.value = value;
}
}
