/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.eventing.dialog.classes;
/**
* \class SosTabJOC
*
* \brief SosTabJOC -
*
* \details
*
* \section SosTabJOC.java_intro_sec Introduction
*
* \section SosTabJOC.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 25.01.2012
* \see reference
*
* Created on 25.01.2012 11:47:41
 */
import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;

import sos.util.SOSStandardLogger;

import com.sos.dashboard.globals.SOSDashboardOptions;
import com.sos.eventing.frontend.ActionShowDialog;
import com.sos.eventing.frontend.Scheduler;

public class SOSTabEventHandlerList extends CTabItem {

	private static final String	conSectionPLUGIN_ACTION_SHOW_DIALOG	= "plugin_action_show_dialog";
	private static Logger logger = Logger.getLogger(SOSTabEventHandlerList.class);

	private final Composite	parentComposite;
	private final GridLayout	layout;
    private Table table;
    private String eventhandlerDirectory;
	private Scheduler scheduler = new Scheduler();
	private ActionShowDialog eventHandlerView;
    private SOSDashboardOptions           objOptions                          = null;


	public SOSTabEventHandlerList(final String caption, final CTabFolder parentTabfolder, final String host, final int port, final String _eventhandlerDirectory) {
		super(parentTabfolder, SWT.NONE);
		setText(caption);
		eventhandlerDirectory = _eventhandlerDirectory;
	    scheduler = new Scheduler();
		scheduler.setHostName(host);
		scheduler.setTcpPort(String.valueOf(port));
		parentComposite = new Composite(parentTabfolder, SWT.NONE);
		layout = new GridLayout(1, false);
		parentComposite.setLayout(layout);
		createContent();

		parentComposite.layout();
		this.setControl(parentComposite);
	}

	private void createContent(){
		try {

			SOSStandardLogger sosLogger = new SOSStandardLogger(9);
			eventHandlerView =  new ActionShowDialog(parentComposite, scheduler, eventhandlerDirectory, sosLogger);
			eventHandlerView.setObjOptions(objOptions);
			eventHandlerView.showComposite();
            table = eventHandlerView.getTableEvents();
		}
		catch (Exception e) {
			logger.error(String.format("could not create event handler view: %s",e.getMessage()));
			e.printStackTrace();
		}

	}

	public Composite getParentComposite() {
		return parentComposite;
	}

	public Table getTable() {
		return table;
	}



	public void setEventhandlerDirectory(final String eventhandlerDirectory) {
		this.eventhandlerDirectory = eventhandlerDirectory;
		eventHandlerView.setConfigurationDirectory(eventhandlerDirectory);
	}

	public void setPort(final int port){
		scheduler.setTcpPort(String.valueOf(port));
		eventHandlerView.setScheduler(scheduler);
	}

	public void setObjOptions(final SOSDashboardOptions objOptions) {
		this.objOptions = objOptions;
	}

	public void disableRefresh(){
		eventHandlerView.disableRefresh();
	}

	public void enableRefresh(){
		eventHandlerView.resetRefreshTimer();
	}
}
