/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.eventing.dialog.classes;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;

import sos.util.SOSStandardLogger;

import com.sos.eventing.frontend.EventShowDialog;
import com.sos.eventing.frontend.Scheduler;

@SuppressWarnings("deprecation")
public class SOSTabEventList extends CTabItem {
	private final Composite	parentComposite;
	private final GridLayout	layout;
	private Table table;
	private final Scheduler scheduler;
	EventShowDialog eventList;

	public SOSTabEventList(final String caption, final CTabFolder parentTabfolder, final String host, final int port) {
		super(parentTabfolder, SWT.NONE);
		setText(caption);

		scheduler = new Scheduler();
		scheduler.setHostName(host);
		scheduler.setTcpPort(String.valueOf(port));

		parentComposite = new Composite(parentTabfolder, SWT.NONE);
		layout = new GridLayout(1, false);
		parentComposite.setLayout(layout);
	    parentComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		createContent();

		parentComposite.layout();
		this.setControl(parentComposite);
	}

	private void createContent(){

		try {

		    SOSStandardLogger sosLogger = new SOSStandardLogger(9);
		    eventList = new EventShowDialog(parentComposite, scheduler, sosLogger);
		    eventList.showComposite();
            table = eventList.getTable();
		} catch (Exception e) {
 			e.printStackTrace();
		}
	}

	public Composite getParentComposite() {
		return parentComposite;
	}

	public Table getTable() {
		return table;
	}

	public void setPort(final int port){
		scheduler.setTcpPort(String.valueOf(port));
		eventList.setScheduler(scheduler);
	}

	public void disableRefresh(){
		eventList.disableRefresh();
	}

	public void enableRefresh(){
		eventList.resetRefreshTimer();
	}

}
