/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.history.db;

import java.io.IOException;
 

import javax.persistence.Column;

import javax.persistence.Lob;
import javax.persistence.MappedSuperclass;

import javax.persistence.Transient;

import org.apache.log4j.Logger;

import com.sos.hibernate.classes.DbItem;
import com.sos.scheduler.history.classes.SOSStreamUnzip;



/**
* \class SchedulerHistoryLogDBItem
*
* \brief SchedulerHistoryLogDBItem -
*
* \details
*
* \section SchedulerHistoryLogDBItem.java_intro_sec Introduction
*
* \section SchedulerHistoryLogDBItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 13.05.2011
* \see reference
*
* Created on 13.05.2011 16:42:58
 */

@MappedSuperclass
public class SchedulerHistoryLogDBItem extends  DbItem {

     @SuppressWarnings("unused")
	private static Logger       logger          = Logger.getLogger(SchedulerHistoryLogDBItem.class);
    private byte[] log;
     
  	public SchedulerHistoryLogDBItem() {

	}

   //Wenn PGSQL verwendet wird, muss die Annotation LOB entfernt werden.
   //Es gibt in der Auslieferung den JAR com.sos.hibernate_pgsql.jar, der nur diese eine Klasse ohne @LOB enthlt
   //com.sos.hibernate_pgsql.jar muss dann dem Klassenpfad hinzugefgt werden, wenn PGSQL verwendet wird.
  	
	  @Lob
	  @Column(name="`LOG`", nullable=true)
		public byte[] getLog() {
			return log;
		}

	  @Column(name="`LOG`", nullable=true)
		public void setLog(final byte[] log) {
			this.log = log;
		}

	  
	  @Transient 
	  public String getLogAsString() throws IOException {
		   if (log == null) {
			   return null;
		   }else {
			   SOSStreamUnzip SOSUnzip = new SOSStreamUnzip(log);
			   return SOSUnzip.unzip2String();
		   }
	  }   
}

