/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: soswnmai.cxx 11394 2005-04-03 08:30:29Z jz $

#include "precomp.h"
//#define MODULE_NAME "soswnmai"
//#define COPYRIGHT   " 1995 SOS GmbH Berlin"
//#define AUTHOR      "Joacim Zschimmer"

/* Applikation, die main() ruft.
   Mit Fenster.

   Nicht in einer Bibliothek halten. Explizit einbinden!
*/

#include "sysdep.h"

//#if defined __BORLANDC__
//#   include <cstring.h>
//#   include <except.h>
//#elif defined SYSTEM_SOLARIS
//#   include <exception.h>
//#endif
#include "sysxcept.h"

#include "sosstrng.h"
#include "sos.h"
#include "sosappl.h"    // Sos_static
#include "sosprog.h"    // MFC
#include "log.h"


namespace sos 
{
    extern int sos_main0( int argc, char** argv );
}


#if defined SYSTEM_WIN

namespace sos 
{
    HINSTANCE _hinstance = 0;     //jz 25.7.96   wird von sossv.cxx oder WinMain() gesetzt

#   if defined SYSTEM_STARVIEW

        struct Sos_standard_application : Sos_application
        {
            virtual void _main( int, char*[] );
        };


        void Sos_standard_application::_main( int argc, char* argv[] )
        {
            sos_main0( argc, argv );
        }

        Sos_standard_application sos_application;
#   else
        //int       _argc;
        //char**    _argv;

//--------------------------------------------------------------------Sos_program::InitInstance

BOOL Sos_program::InitInstance()
{
    _hinstance = AfxGetInstanceHandle();

    char  progname [ _MAX_PATH ];
    char* cmd_line = strdup( c_str( m_lpCmdLine ) );
    char* p        = cmd_line;

    _argv = (char**) malloc( sizeof(char**) * 1000 );

    progname[ 0 ] = '\0';
    progname[ sizeof progname - 1 ] = '\0';
    GetModuleFileName( _hinstance, progname, sizeof progname );
    _argv[ 0 ] = progname;
    _argc = 1;

    while( *p  &&  _argc < 1000 )
    {
        _argv[ _argc++ ] = p;
        p = strchr( p, ' ' );
        if( !p )  break;
        while( *p == ' ' )  p++;
        p[-1] = '\0';
    }

    //?ohne catch jz 8.3.97: _sos_appl.init();

    sos_main0( _argc, _argv );   // Ruft sos_main()

    return FALSE;  // MFC soll nicht Run() rufen, sondern Anwendung beenden
}

# endif

} //namespace sos

#else
/*
    namespace sos
    {
        int    _argc;
        char** _argv;
    }
*/
    extern "C" int main( int argc, char** argv )
    {
        using namespace sos;

        _argc = argc;
        _argv = argv;

        int rc = sos_main0( argc, argv );

        return rc;
    }

#endif



/*
    int       _argc;
    char**    _argv;


    int WINAPI WinMain( HINSTANCE hinstance, HINSTANCE, LPSTR lpszCmdLine, int )
    {
        _hinstance = hinstance;

        char  progname [ _MAX_PATH ];
        char* cmd_line = strdup( lpszCmdLine );
        char* p        = cmd_line;

        _argv = (char**) malloc( sizeof(char**) * 1000 );

        progname[ 0 ] = '\0';
        progname[ sizeof progname - 1 ] = '\0';
        GetModuleFileName( hinstance, progname, sizeof progname );
        _argv[ 0 ] = progname;
        _argc = 1;

        while( *p  &&  _argc < 1000 ) {
            _argv[ _argc++ ] = p;
            p = strchr( p, ' ' );
            if( !p )  break;
            while( *p == ' ' )  p++;
            p[-1] = '\0';
        }

        return sos_main0( argc, argv );
    }
*/


