/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// zschimmer.cxx                                     2000 Joacim Zschimmer
// $Id: argv.cxx 13199 2007-12-06 14:15:42Z jz $

// 1693

#include "zschimmer.h"
#include "argv.h"

using namespace std;


namespace zschimmer {

//----------------------------------------------------------------------------------get_argv_option

bool get_argv_option( const char* argv_i, const string& option )
{
    return argv_i == option;
}

//----------------------------------------------------------------------------------get_argv_option

bool get_argv_option( const char* argv_i, const string& prefix, string* result )
{
    if( string_begins_with( argv_i, prefix ) )
    {
        result->assign( argv_i + prefix.length() );
        return true;
    }
    else
        return false;
}

//----------------------------------------------------------------------------------get_argv_option

bool get_argv_option( const char* argv_i, const string& prefix, int* result )
{
    string result_string;

    if( get_argv_option( argv_i, prefix, &result_string ) )
    {
        try
        {
            *result = as_int( result_string );
        }
        catch( Xc& x )
        {
            x.append_text( prefix );
            throw;
        }

        return true;
    }
    else
        return false;
}

//----------------------------------------------------------------------------------get_argv_option

bool get_argv_option( const char* argv_i, const string& prefix, bool* result )
{
    string result_string;

    if( get_argv_option( argv_i, prefix, &result_string ) )
    {
        try
        {
            *result = as_bool( result_string );
        }
        catch( Xc& x )
        {
            x.append_text( prefix );
            throw;
        }

        return true;
    }
    else
        return false;
}

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer
