/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#ifndef __ZSCHIMMER_XSLT_LIBXML2_H
#define __ZSCHIMMER_XSLT_LIBXML2_H

#include "xml_java.h"
#include "z_com_server.h"
#include "../javaproxy/com__sos__scheduler__engine__kernel__xml__CppXsltStylesheet.h"
#include "../javaproxy/java__util__HashMap.h"

namespace zschimmer {
namespace xml {

struct Xslt_stylesheet;
typedef ::javaproxy::com::sos::scheduler::engine::kernel::xml::CppXsltStylesheet CppXsltStylesheetJ;
typedef ::javaproxy::java::util::HashMap HashMapJ;

//----------------------------------------------------------------------------------Xslt_parameters

struct Xslt_parameters : Non_cloneable
{
                                Xslt_parameters             ( int count = 0 );
                               ~Xslt_parameters             ();

    void                        allocate                    ( int size );
    void                        set_xpath                   ( int i, const string& name, const string& value );
    void                        set_string                  ( int i, const string& name, const string& value );

  private:
    friend                      struct Xslt_stylesheet;

    struct Parameter {
        string _name;
        string _value;
    };

    std::vector<Parameter>      _parameters;
    HashMapJ                    _hashMapJ;
};

//----------------------------------------------------------------------------------Xslt_stylesheet

struct Xslt_stylesheet {
                                Xslt_stylesheet             ();
                               ~Xslt_stylesheet             ();

    void                        release                     ()                                      {}
    bool                        is_xml                      ( const string& );
    bool                        is_xml                      ( const BSTR );
    string                      path                        () const                                { return _path; }
    void                        load                        ( const Document_ptr& stylesheet );
    bool                        loaded                      () const                                { return _stylesheetJ != NULL; }
    void                        load_file                   ( const string& filename );
    void                        set_parameter               ( const string& name, const string& value );
    Document_ptr                apply                       ( const Document_ptr& );
    Document_ptr                apply                       ( const Document_ptr&, const Xslt_parameters& );
    string                      xml_from_result             ( const Document_ptr& );

  private:
    CppXsltStylesheetJ         _stylesheetJ;
    string                     _path;
};

//-------------------------------------------------------------------------------------------------

} //namespace xml
} //namespace zschimmer

#endif
