/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: z_windows_directory.h 12116 2006-06-06 18:03:24Z jz $

#ifndef __Z_WINDOWS_DIRECTORY_H
#define __Z_WINDOWS_DIRECTORY_H

#include <io.h>
#include "regex_class.h"

namespace zschimmer {
namespace windows {

//--------------------------------------------------------------------------Simple_directory_reader

struct Simple_directory_reader : Simple_directory_reader_base
{
                                    Simple_directory_reader ()                                      : _handle(-1), _zero_(this+1) {}
                                    Simple_directory_reader ( const std::string& path, Flags flags,
                                                              const std::string& pattern = "*" )    : _handle(-1), _zero_(this+1) { open( path, flags, pattern ); }
    virtual                        ~Simple_directory_reader ()                                      { close();  }

    void                            open                    ( const std::string& path, Flags flags, const std::string& pattern );
    void                            close                   ();
    string                          get                     ();

  private:
    Fill_zero                      _zero_;
#ifdef Z_WINDOWS
    intptr_t                       _handle;
#else
    int                            _handle;
#endif
    Flags                          _flags;
    Regex                          _regex;
    bool                           _is_first_entry;
    _finddatai64_t                 _entry;
};

//-------------------------------------------------------------------------------------------------

} //namespace windows
} //namespace zschimmer

#endif
