/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: z_windows_window.cxx 13199 2007-12-06 14:15:42Z jz $

#include "zschimmer.h"
#include "z_windows_window.h"
#include "z_com.h"
#include "log.h"

using namespace std;

namespace zschimmer {
namespace windows {

//-------------------------------------------------------------------------------Window::class_name
    
string Window::class_name()
{
    char buffer [1000+1];
    int length = GetClassName( _handle, buffer, NO_OF( buffer ) );
    return length? buffer : "";
}

//----------------------------------------------------------------------------Window::internal_text

string Window::internal_text()
{
    string   result;
    int      size    = 10000+1;
    OLECHAR* wbuffer = new OLECHAR[ size ];
    int      length  = InternalGetWindowText( _handle, wbuffer, size );

    if( length )  result = com::string_from_ole( wbuffer );

    delete [] wbuffer;
    return result;
}

//-------------------------------------------------------------------------------------Window::text

string Window::text()       
{
    string   result;
    int      size   = 10000+1;
    char*    buffer = new char[ size ];
    int      length = GetWindowText( _handle, buffer, size );      // GetWindowText liefert nicht den Inhalt eines Edit-Controls!

    if( length )  result = buffer;

    delete [] buffer;
    return result;
}

//-------------------------------------------------------------------------------------Window::info

WINDOWINFO Window::info()
{
    WINDOWINFO result;

    BOOL ok = GetWindowInfo( _handle, &result );
    if( !ok )  throw_mswin( "GetWindowInfo" );

    return result;
}

//-------------------------------------------------------------------------------------------------

} //namespace windows
} //namespace zschimmer
